/*
   Myfv.c

  This program allows to display binary files one screenful at a time or
  a certain number of lines, as selected by the user, and prompts the user
  for extra display.  It allows to go back in the file, forward, to print line
  numbers and to search for strings.

  This code has been modified from the solution to assignment 3, written by
  Mashrur Mia.

  Marc-Andre Laverdiere
  ID:4469526
  Department of Computer Science
  Concordia University
  (c) 2001

  Note: this program can be modified and distributed, as long as the credentials are kept integrally in the distribution.
*/

/*
  myfv_static.c
  This program, when linked with myfv_dyn.c and myfv_main.c, will produce the program myfv. It requires functions from myfv_dyn in order to work correctly.

*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>  
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define DEFAULT 22

void get_str_lines_nos(int srcfile, int dstfile, char *str);
void add_line_nos(int srcfile, int dstfile);
void show_prev(int file, int lines);
void show_next(int file, int lines);
int readline(int cfd, char *line, int n);
void skip_lines(int file, int lines);


char readc(int *a){
struct termios save;              
struct termios newt;                     
char c;                                   
char line[3];
 
tcgetattr(0,&save);                     
newt = save;                            
newt.c_lflag &= (~ICANON);              
newt.c_lflag &= (~ECHO); 
newt.c_cc[VTIME]=0;
newt.c_cc[VMIN]=1;
tcsetattr(0,TCSANOW,&newt);   
read(0,&c,1);
if(c=='f'|| c=='b'){
 write(1,&c,1);
 read(0,line,1);
 if (line[0] == '\n')
   {
     *a=DEFAULT; 
     return c;
   }             
  if(*line=='1' || *line=='2'){
      write(1,line,1); 
      read(0,line+1,1);
      line[2]='\0';
   }
  else
    line[1]='\0';
  *a = atoi(line);
}

tcsetattr(0,TCSANOW,&save);              
             
return c;
}


void show_lines(int file, int pagesize){

  
  char c;
  char output[256] ="Press fn to view n lines forward, bn to view n lines backward, or q to quit";
  char erase[256]=  "\r                                                                              \r";
  int len = strlen(output);  
  int elen = strlen(erase);
  int numlines = DEFAULT;
    
  reset();
  show_next(file,pagesize);
  
  do{
    write(1,output,len);
    c=readc(&numlines);
    write(1,erase,elen);
    switch(c){
    case 'f':
      show_next(file,numlines);
      break;
    case 'b':
      show_prev(file,numlines);
     
    }
       
  }while(c!='q');
  
}


void show_file(int a, char* b[]){
  int dstfile;
  int srcfile;
  int SeekResult;
  char line[256];

  sprintf(line,"usage : %s [-N|-Number][-F n | -From n][string] filename \n",b[0]);

  
  if(a<2 || a>6)
    write(1,line,strlen(line));
  else{
    if((srcfile=open(b[a-1],O_RDONLY))<0)
      perror(b[a-1]);
    else{
      if(a!=2){
	if((dstfile=open(".filename",O_RDWR|O_CREAT|O_TRUNC,S_IWUSR|S_IRUSR))<0)
	  perror(".filename");
	else{
	  if(a==3){
	    if(!strcmp(b[1],"-N") || !strcmp(b[1],"-Number"))
	      {
		add_line_nos(srcfile,dstfile);
		SeekResult = lseek(dstfile,0,SEEK_SET);
	      }
	    else
	      {
		get_str_lines(srcfile,dstfile,b[1]);
		SeekResult = lseek(dstfile,0,SEEK_SET);
	      }
	  }
	  else{
	    if(a==4)
	       if(!strcmp(b[1],"-N") || !strcmp(b[1],"-Number"))
		 {
		   get_str_lines_nos(srcfile,dstfile,b[2]);
		   SeekResult = lseek(dstfile,0,SEEK_SET);
		 }
	       else
	         if(!strcmp(b[1],"-F") || !strcmp(b[1],"-From"))
		   if(atoi(b[2])) /*if integer argument*/
		     {
		       skip_lines(srcfile,atoi(b[2]));
		       show_lines(srcfile,DEFAULT);
		       close(srcfile);
		       close(dstfile);
		       return;
		     }
		   else
		   {
		     write(1,line,strlen(line));
	             return;  
		   }
                 else
		   {
		     write(1,line,strlen(line));
	             return;
		   }
            else
	    if(a==5)
	    if(!strcmp(b[1],"-N") || !strcmp(b[1],"-Number")) /*case: myfv -N -F int <file> */
		  if(!strcmp(b[2],"-F") || !strcmp(b[2],"-From"))
		    if (atoi(b[3]))
		      {
			add_line_nos(srcfile,dstfile);
			close(srcfile);
			SeekResult = lseek(dstfile,0,SEEK_SET);
			skip_lines(dstfile,atoi(b[3]));
		      }
		    else
		      {
			write(1,line,strlen(line));
			return;
		      }
		  else
		    {
		      write(1,line,strlen(line));
		      return;
		    }
	      else /*case: myfv -F int str <file>*/
		if(!strcmp(b[1],"-F") || !strcmp(b[1],"-From"))
		  if(atoi(b[2]))
		   {
		     get_str_lines(srcfile,dstfile,b[3]);
		     SeekResult = lseek(dstfile,0,SEEK_SET);
		     skip_lines(dstfile,atoi(b[2]));
		   }
                  else
		   {
		      write(1,line,strlen(line));
		      return;
		   }
                else
		 {
	            write(1,line,strlen(line));
	            return;
	         }

	    else
	    if((!strcmp(b[1],"-N") || !strcmp(b[1],"-Number")) && (!strcmp(b[2],"-F") || !strcmp(b[2],"-From")) && (atoi(b[3])))
	         {
		   get_str_lines_nos(srcfile,dstfile,b[4]);
		   SeekResult = lseek(dstfile,0,SEEK_SET);
		   skip_lines(dstfile,atoi(b[3]));
	         }
            else
		 {
		   write(1,line,strlen(line));
		   return;
		 }
	      
	  }
	  close(srcfile);
	  show_lines(dstfile,DEFAULT);
	  close(dstfile);
	  if(unlink(".filename")<0)
	    perror(".filename");
	}
      }
      else{
	show_lines(srcfile,DEFAULT);
	close(srcfile);
      }
    }
  }
  

}

